# Copyright (c) 2011 Cloudera, Inc. All rights reserved.

from cmf.monitor.json_metrics_utils import get_leaf_dict

class JsonParser(object):
  def __init__(self, json_dict):
    """
    May raise ParseError if the json structure is not what
    we expect.
    """
    self._json = json_dict
    self.jobtracker = get_leaf_dict(self._json, 'mapred', 'jobtracker')
    self.jvm = get_leaf_dict(self._json, 'jvm', 'metrics')

#
# This is what the JT json looks like:
#
SAMPLE = """
  {
    "fairscheduler":{
      "pools":[

      ]
    },
    "jvm":{
      "metrics":[
        [
          {
            "hostName":"dsom",
            "processName":"JobTracker",
            "sessionId":""
          },
          {
            "gcCount":1,
            "gcTimeMillis":5,
            "logError":0,
            "logFatal":0,
            "logInfo":43,
            "logWarn":1,
            "maxMemoryM":910.25,
            "memHeapCommittedM":118.875,
            "memHeapUsedM":32.283775,
            "memNonHeapCommittedM":23.1875,
            "memNonHeapUsedM":17.054413,
            "threadsBlocked":1,
            "threadsNew":2,
            "threadsRunnable":3,
            "threadsTerminated":4,
            "threadsTimedWaiting":5,
            "threadsWaiting":6
          }
        ]
      ]
    },
    "mapred":{
      "jobtracker":[
        [
          {
            "hostName":"dsom",
            "sessionId":""
          },
          {
            "blacklisted_maps":0,
            "blacklisted_reduces":0,
            "heartbeats":0,
            "jobs_completed":1,
            "jobs_failed":2,
            "jobs_killed":3,
            "jobs_preparing":4,
            "jobs_running":5,
            "jobs_submitted":15,
            "map_slots":8,
            "maps_completed":0,
            "maps_failed":2,
            "maps_killed":0,
            "maps_launched":0,
            "occupied_map_slots":1,
            "occupied_reduce_slots":2,
            "reduce_slots":6,
            "reduces_completed":0,
            "reduces_failed":3,
            "reduces_killed":0,
            "reduces_launched":0,
            "reserved_map_slots":0,
            "reserved_reduce_slots":0,
            "running_maps":0,
            "running_reduces":0,
            "trackers":0,
            "trackers_blacklisted":2,
            "trackers_decommissioned":0,
            "waiting_maps":0,
            "waiting_reduces":0
          }
        ]
      ]
    },
    "rpc":{
      "detailed-metrics":[
        [
          {
            "hostName":"dsom",
            "port":"8021"
          },
          {
            "getProtocolVersion_avg_time":0,
            "getProtocolVersion_num_ops":0
          }
        ]
      ],
      "metrics":[
        [
          {
            "hostName":"dsom",
            "port":"8021"
          },
          {
            "NumOpenConnections":0,
            "ReceivedBytes":0,
            "RpcProcessingTime_avg_time":0,
            "RpcProcessingTime_num_ops":0,
            "RpcQueueTime_avg_time":0,
            "RpcQueueTime_num_ops":0,
            "SentBytes":0,
            "callQueueLen":0,
            "rpcAuthenticationFailures":0,
            "rpcAuthenticationSuccesses":0,
            "rpcAuthorizationFailures":0,
            "rpcAuthorizationSuccesses":0
          }
        ]
      ]
    },
    "ugi":{
      "ugi":[
        [
          {
            "hostName":"dsom"
          },
          {
            "loginFailure_avg_time":0,
            "loginFailure_num_ops":0,
            "loginSuccess_avg_time":0,
            "loginSuccess_num_ops":0
          }
        ]
      ]
    }
  }
  """
