#!/bin/bash

# Copyright (c) 2012 Cloudera, Inc. All rights reserved.

# Time marker for both stderr and stdout
date; date 1>&2

cloudera_config=`dirname $0`
cloudera_config=`cd "$cloudera_config/../common"; pwd`
. ${cloudera_config}/cdh4-default
. ${cloudera_config}/cloudera-config.sh

# attempt to find java
locate_java_home

echo "using $JAVA_HOME as JAVA_HOME"
echo "using $CDH_VERSION as CDH_VERSION"
echo "using $CONF_DIR as CONF_DIR"
echo "Using $CDH_HTTPFS_HOME as CDH_HTTPFS_HOME"
echo "Using $TOMCAT_HOME as TOMCAT_HOME"

# mirror /etc/default/hadoop-httpfs

HTTPFS_RUN=/var/run/hadoop-httpfs/
export HTTPFS_USER=httpfs
export HTTPFS_CONFIG=$CONF_DIR
export HTTPFS_TEMP=$HTTPFS_RUN
export HTTPFS_CATALINA_HOME=$TOMCAT_HOME
export CATALINA_PID=${HTTPFS_RUN}hadoop-httpfs-httpfs.pid
export CATALINA_BASE=$CDH_HTTPFS_HOME
export CATALINA_TMPDIR=$HTTPFS_RUN

# log related env vars for our log4j.properties
#
# SCM is expected to set the following:
# - HTTPFS_LOG_DIR
# - HTTPFS_LOGFILE
# - HTTPFS_ROOT_LOGGER
# - HTTPFS_HTTP_PORT (pass thru)
# - HTTPFS_ADMIN_PORT (pass thru)

export HTTPFS_LOG=$HTTPFS_LOG_DIR
OPTIONS="$OPTIONS -Dhadoop.log.file=${HTTPFS_LOGFILE}"
OPTIONS="$OPTIONS -Dhadoop.root.logger=${HTTPFS_ROOT_LOGGER}"
export CATALINA_OPTS="$OPTIONS $CATALINA_OPTS"

HTTPFS=$CDH_HTTPFS_HOME/sbin/httpfs.sh

# debug
set -x

# local replacement of substitution variables.
# i.e. master doesn't know final resting place of configuration files
#   which may require absolute path (e.g. dfs_allows)
perl -pi -e "s#{{CMF_CONF_DIR}}#$CONF_DIR#g" $CONF_DIR/*.xml

exec ${HTTPFS} run
