-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 28 of the CMF schema. Migration code to be applied on top of the
-- previous version. Technically, the schema isn't changed but we rely on
-- the schema version to trigger running of the ddl files.
--

update SCHEMA_VERSION set VERSION=28;

-- 1) Mutate TT final flag configs to TT overrides

update CONFIGS
   set ATTR='override_mapred_child_java_opts_max_heap',
       VALUE=c2.VALUE
   from CONFIGS c2 where
   COALESCE(CONFIGS.ROLE_ID, 0)=COALESCE(c2.ROLE_ID, 0) and
   COALESCE(CONFIGS.ROLE_TYPE, '')=COALESCE(c2.ROLE_TYPE, '') and
   CONFIGS.SERVICE_ID=c2.SERVICE_ID and
   CONFIGS.REVISION_ID=c2.REVISION_ID and
   CONFIGS.VALUE='true' and
   CONFIGS.ATTR='mapred_child_java_opts_max_heap_final' and
   c2.ATTR='mapred_child_java_opts_max_heap';

update CONFIGS
   set ATTR='override_mapred_child_ulimit',
       VALUE=c2.VALUE
   from CONFIGS c2 where
   COALESCE(CONFIGS.ROLE_ID, 0)=COALESCE(c2.ROLE_ID, 0) and
   COALESCE(CONFIGS.ROLE_TYPE, '')=COALESCE(c2.ROLE_TYPE, '') and
   CONFIGS.SERVICE_ID=c2.SERVICE_ID and
   CONFIGS.REVISION_ID=c2.REVISION_ID and
   CONFIGS.VALUE='true' and
   CONFIGS.ATTR='mapred_child_ulimit_final' and
   c2.ATTR='mapred_child_ulimit';

update CONFIGS
   set ATTR='override_mapred_job_reuse_jvm_num_tasks',
       VALUE=c2.VALUE
   from CONFIGS c2 where
   COALESCE(CONFIGS.ROLE_ID, 0)=COALESCE(c2.ROLE_ID, 0) and
   COALESCE(CONFIGS.ROLE_TYPE, '')=COALESCE(c2.ROLE_TYPE, '') and
   CONFIGS.SERVICE_ID=c2.SERVICE_ID and
   CONFIGS.REVISION_ID=c2.REVISION_ID and
   CONFIGS.VALUE='true' and
   CONFIGS.ATTR='mapred_job_reuse_jvm_num_tasks_final' and
   c2.ATTR='mapred_job_reuse_jvm_num_tasks';

-- 2) Move roleType level client configs from JOB/TASKTRACKER to BASTION

update CONFIGS
    set ROLE_TYPE='BASTION' where 
        ROLE_TYPE='TASKTRACKER' and
        ATTR in ('mapred_output_compress',
                 'mapred_output_compression_type',
                 'mapred_output_compression_codec',
                 'mapred_compress_map_output',
                 'mapred_map_output_compression_codec',
                 'mapred_child_java_opts_base',
                 'mapred_child_java_opts_max_heap',
                 'mapred_child_ulimit',
                 'mapred_job_reuse_jvm_num_tasks',
                 'io_sort_factor',
                 'io_sort_mb',
                 'io_sort_record_percent',
                 'io_sort_spill_percent',
                 'mapred_reduce_parallel_copies');

update CONFIGS
    set ROLE_TYPE='BASTION' where 
        ROLE_TYPE='JOBTRACKER' and
        ATTR='mapred_reduce_tasks';


-- 3) Rename TT instance values for autoconfigs

update CONFIGS
    set ATTR='autoconfig_mapred_child_java_opts_max_heap' where
        ROLE_ID is not null and
        ATTR='mapred_child_java_opts_max_heap';

update CONFIGS
    set ATTR='autoconfig_io_sort_mb' where
        ROLE_ID is not null and
        ATTR='io_sort_mb';

-- 4) Delete remaining TT configs

delete from CONFIGS where
    ROLE_ID is not null and
    ATTR in ('mapred_output_compress',
             'mapred_output_compression_type',
             'mapred_output_compression_codec',
             'mapred_compress_map_output',
             'mapred_map_output_compression_codec',
             'mapred_child_java_opts_base',
             'mapred_child_java_opts_max_heap',
             'mapred_child_ulimit',
             'mapred_job_reuse_jvm_num_tasks',
             'io_sort_factor',
             'io_sort_mb',
             'io_sort_record_percent',
             'io_sort_spill_percent',
             'mapred_reduce_parallel_copies',
             'mapred_reduce_tasks');

delete from CONFIGS where
    ATTR in ('mapred_child_java_opts_max_heap_final',
             'mapred_child_ulimit_final',
             'mapred_job_reuse_jvm_num_tasks_final');
