// Copyright (c) 2011-2012 Cloudera, Inc.  All rights reserved.
define([], function() {
	$.fn.SmartTableTip = function(options) {

		return this.each(function() {
			$table = $(this);

			//Build tooltip wrapper table
			var $label = $table.clone();
			$labelInner = $('<th />');
			$label.find('thead').remove();
			$label.find('tbody').remove();
			$label
				.css('margin', 0)
				.css('padding', 0)
				.css('border', 0)
				.append('<tbody />')
				.children()
				.append('<tr />')
				.children()
				.append($labelInner);

			$label
				.addClass('hidden')
				.css('position', 'absolute');

			//Insert hidden tooltip wrapper table
			$('body').prepend($label);

			// Display the tooltup in the proper location
			// and populate it with the content of the
			// first cell in a tr when we mouse over an
			// input in that tr.

			var LABEL_OFFSET = 5;

			$table.delegate('input', 'mouseover', function (e) {
				var $first = $(this).parents('tr').find('td:first');
				$labelInner.html($first.html());
				$label
					.css('left', e.pageX - $label.width() - LABEL_OFFSET)
					.css('top', e.pageY - $label.height() - LABEL_OFFSET)
					.width($first.width())
					.removeClass('hidden');
			});

			$table.delegate('input', 'mouseout', function (e) {
				$label.addClass('hidden');
			});

			$table.delegate('input', 'mousemove', function (e) {
				$label
					.css('left', e.pageX - $label.width() - LABEL_OFFSET)
					.css('top', e.pageY - $label.height() - LABEL_OFFSET);
			});

		});
	};
});
